	program arcx(input,tape1,tape2,output)
	implicit integer(a-z)
c
c  read a file name from input in hex ascii,
c  and extract it from archive tape1 into tape2.
c
	integer name(28)
	fit=0
c  check magic number
	do 1 i=1,4
	if(getzrif(c).lt.0)goto 16
1	fit=or(shift(fit,4),c)
	if(fit.ne.62777b)goto 16
	read 20,(name(i),i=1,28)
2	fit=1
c  check name
	do 3 i=1,28
	if(getzrif(c).lt.0)goto 17
	c=c+1r0
	if(c.gt.1r9)c=c-1r9
	if(c.ne.name(i))fit=0
3	continue
c  skip irrelevant header
	do 4 i=1,16
4	call getzrif(c)
c  compute size
	n=getchar(dmy)
	n=or(n,shift(getchar(dmy),8))
	n=or(shift(n,16),getchar(dmy))
	n=or(n,shift(getchar(dmy),8))
	print*,n
	n=((n+1)/2)*4
	if(fit.ne.0)goto 5
c  skip other files
	call skip(n)
	goto 2
5	do 6 i=1,n
	if(getzrif(c).lt.0)goto 17
	call putzrif(c)
6	continue
	call flush
	rewind 2
	stop
16	print *,"not an archive"
17	print *,"not found"
	stop
20	format(28r1)
	end

	integer function getzrif(c)
	implicit integer(a-z)
c
c  get the next 4-bit half-byte from unit 1.
c  the actual reading is done by buffer in,
c  this routine transmittes one half-byte (zrif) at a time.
c  end of file is marked by a negative return.
c
	common /s/ nz
	integer block(120), nzrif
	real unit
	data nzrif /1200/
	data    nz /0/
	data parity /0/
	if(nzrif .gt. 1023)goto 20
1	word = block(nzrif/15+1)
	sh = mod(nzrif, 15) * 4
	c = shift(and(mask(4), shift(word,sh)), 4)
	getzrif = 1
	nzrif = nzrif + 1
	nz = nz + 1
	return
20	nzrif=0
c
c 2nd arg to buffer-in (i.e. 1) is for direct tape reading,
c and means "no conversion" (record manager "cm=no").
c
	buffer in(1, 1)(block(1), block(69))
	cod = unit(1)
	if(cod .eq. -1)goto 1
	if(cod .eq. 1)call system(52, " read parity error")
c  cod should be zero now
	c = 0
	getzrif = -1
	return
	end

	subroutine skip(nn)
c
c read to end of block,then read whole blocks,
c  then read to end of file in the last block
c
	common /s/ nz
	integer bloc(70),c
	n=nn
1	if(mod(nz,1024).eq.0)goto 2
	if(getzrif(c).lt.0)return
	n=n-1
	if(n.eq.0)return
	goto 1
2	if(n.lt.1024)goto 3
	buffer in(1,1)(bloc(1),bloc(69))
	nz=nz+1024
	n=n-1024
	if(unit(1))2,4,4
3	if(n.eq.0)return
	if(getzrif(c).lt.0)return
	n=n-1
	goto 3
4	return
	end

	subroutine putzrif(c)
c
c  opposite of getzrif
c
	integer c,block(70),nzrif,word,n
	data    nzrif /0/
	n=nzrif/15+1
	m=mod(nzrif,15)
	word=block(n)
	if(m.eq.0)word=0
	word=or(shift(word,4),c)
	block(n)=word
	if(nzrif.ge.1023)goto 20
	nzrif=nzrif+1
	return
c
	entry flush
20	block(n)=shift(block(n),4*(14-m))
	n1=n+1
	do 21 i=n1,70
21	block(i)=0
	buffer out(2,1)(block(1),block(n))
	if(unit(2))30,30,30
30	nzrif=0
	return
	end

	integer function getchar(dmy)
c
c  combine 2 halfbytes to an ascii char
c
	integer c,g
	call getzrif(c)
	g=c
	if(getzrif(c).lt.0)c=-1
	getchar=or(shift(g,4),c)
	return $ end
